Index: lemon/bits/debug_map.h
===================================================================
--- lemon/bits/debug_map.h	(revision 2333)
+++ lemon/bits/debug_map.h	(revision 2384)
@@ -112,11 +112,11 @@
     /// It adds all the items of the graph to the map.
     DebugMap(const Graph& graph) {
-      Parent::attach(graph.getNotifier(Item()));
-      container.resize(Parent::getNotifier()->maxId() + 1);
-      flag.resize(Parent::getNotifier()->maxId() + 1, false);
-      const typename Parent::Notifier* notifier = Parent::getNotifier();
-      Item it;
-      for (notifier->first(it); it != INVALID; notifier->next(it)) {
-        flag[Parent::getNotifier()->id(it)] = true;
+      Parent::attach(graph.notifier(Item()));
+      container.resize(Parent::notifier()->maxId() + 1);
+      flag.resize(Parent::notifier()->maxId() + 1, false);
+      const typename Parent::Notifier* notifier = Parent::notifier();
+      Item it;
+      for (notifier->first(it); it != INVALID; notifier->next(it)) {
+        flag[Parent::notifier()->id(it)] = true;
       }
     }
@@ -127,11 +127,11 @@
     /// It adds all the items of the graph to the map.
     DebugMap(const Graph& graph, const Value& value) {
-      Parent::attach(graph.getNotifier(Item()));
-      container.resize(Parent::getNotifier()->maxId() + 1, value);
-      flag.resize(Parent::getNotifier()->maxId() + 1, false);
-      const typename Parent::Notifier* notifier = Parent::getNotifier();
-      Item it;
-      for (notifier->first(it); it != INVALID; notifier->next(it)) {
-        flag[Parent::getNotifier()->id(it)] = true;
+      Parent::attach(graph.notifier(Item()));
+      container.resize(Parent::notifier()->maxId() + 1, value);
+      flag.resize(Parent::notifier()->maxId() + 1, false);
+      const typename Parent::Notifier* notifier = Parent::notifier();
+      Item it;
+      for (notifier->first(it); it != INVALID; notifier->next(it)) {
+        flag[Parent::notifier()->id(it)] = true;
       }
     }
@@ -142,13 +142,13 @@
     DebugMap(const DebugMap& _copy) : Parent() {
       if (_copy.attached()) {
-	Parent::attach(*_copy.getNotifier());
+	Parent::attach(*_copy.notifier());
 	container = _copy.container;
       }
-      flag.resize(Parent::getNotifier()->maxId() + 1, false);
-      const typename Parent::Notifier* notifier = Parent::getNotifier();
-      Item it;
-      for (notifier->first(it); it != INVALID; notifier->next(it)) {
-        flag[Parent::getNotifier()->id(it)] = true;
-        LEMON_ASSERT(_copy.flag[Parent::getNotifier()->id(it)], MapError());
+      flag.resize(Parent::notifier()->maxId() + 1, false);
+      const typename Parent::Notifier* notifier = Parent::notifier();
+      Item it;
+      for (notifier->first(it); it != INVALID; notifier->next(it)) {
+        flag[Parent::notifier()->id(it)] = true;
+        LEMON_ASSERT(_copy.flag[Parent::notifier()->id(it)], MapError());
       }
     }
@@ -158,10 +158,10 @@
     /// Destructor.
     ~DebugMap() {
-      const typename Parent::Notifier* notifier = Parent::getNotifier();
+      const typename Parent::Notifier* notifier = Parent::notifier();
       if (notifier != 0) {
         Item it;
         for (notifier->first(it); it != INVALID; notifier->next(it)) {
-          LEMON_ASSERT(flag[Parent::getNotifier()->id(it)], MapError());
-          flag[Parent::getNotifier()->id(it)] = false;
+          LEMON_ASSERT(flag[Parent::notifier()->id(it)], MapError());
+          flag[Parent::notifier()->id(it)] = false;
         }
       }
@@ -192,5 +192,5 @@
     DebugMap& operator=(const CMap& cmap) {
       checkConcept<concepts::ReadMap<Key, _Value>, CMap>();
-      const typename Parent::Notifier* notifier = Parent::getNotifier();
+      const typename Parent::Notifier* notifier = Parent::notifier();
       Item it;
       for (notifier->first(it); it != INVALID; notifier->next(it)) {
@@ -207,6 +207,6 @@
     /// actual items of the graph.      
     Reference operator[](const Key& key) {
-      LEMON_ASSERT(flag[Parent::getNotifier()->id(key)], MapError());
-      return container[Parent::getNotifier()->id(key)];
+      LEMON_ASSERT(flag[Parent::notifier()->id(key)], MapError());
+      return container[Parent::notifier()->id(key)];
     } 
 		
@@ -216,6 +216,6 @@
     /// actual items of the graph. 
     ConstReference operator[](const Key& key) const {
-      LEMON_ASSERT(flag[Parent::getNotifier()->id(key)], MapError());
-      return container[Parent::getNotifier()->id(key)];
+      LEMON_ASSERT(flag[Parent::notifier()->id(key)], MapError());
+      return container[Parent::notifier()->id(key)];
     }
 
@@ -235,17 +235,17 @@
     /// and it overrides the add() member function of the observer base.     
     virtual void add(const Key& key) {
-      int id = Parent::getNotifier()->id(key);
+      int id = Parent::notifier()->id(key);
       if (id >= (int)container.size()) {
 	container.resize(id + 1);
         flag.resize(id + 1, false);
       }
-      LEMON_ASSERT(!flag[Parent::getNotifier()->id(key)], MapError());
-      flag[Parent::getNotifier()->id(key)] = true;
+      LEMON_ASSERT(!flag[Parent::notifier()->id(key)], MapError());
+      flag[Parent::notifier()->id(key)] = true;
       if (strictCheck) {
         std::vector<bool> fl(flag.size(), false);
-        const typename Parent::Notifier* notifier = Parent::getNotifier();
-        Item it;
-        for (notifier->first(it); it != INVALID; notifier->next(it)) {
-          int id = Parent::getNotifier()->id(it);
+        const typename Parent::Notifier* notifier = Parent::notifier();
+        Item it;
+        for (notifier->first(it); it != INVALID; notifier->next(it)) {
+          int id = Parent::notifier()->id(it);
           fl[id] = true;
         }
@@ -261,5 +261,5 @@
       int max = container.size() - 1;
       for (int i = 0; i < (int)keys.size(); ++i) {
-        int id = Parent::getNotifier()->id(keys[i]);
+        int id = Parent::notifier()->id(keys[i]);
         if (id >= max) {
           max = id;
@@ -269,13 +269,13 @@
       flag.resize(max + 1, false);
       for (int i = 0; i < (int)keys.size(); ++i) {
-        LEMON_ASSERT(!flag[Parent::getNotifier()->id(keys[i])], MapError());
-        flag[Parent::getNotifier()->id(keys[i])] = true;
+        LEMON_ASSERT(!flag[Parent::notifier()->id(keys[i])], MapError());
+        flag[Parent::notifier()->id(keys[i])] = true;
       }
       if (strictCheck) {
         std::vector<bool> fl(flag.size(), false);
-        const typename Parent::Notifier* notifier = Parent::getNotifier();
-        Item it;
-        for (notifier->first(it); it != INVALID; notifier->next(it)) {
-          int id = Parent::getNotifier()->id(it);
+        const typename Parent::Notifier* notifier = Parent::notifier();
+        Item it;
+        for (notifier->first(it); it != INVALID; notifier->next(it)) {
+          int id = Parent::notifier()->id(it);
           fl[id] = true;
         }
@@ -291,15 +291,15 @@
       if (strictCheck) {
         std::vector<bool> fl(flag.size(), false);
-        const typename Parent::Notifier* notifier = Parent::getNotifier();
-        Item it;
-        for (notifier->first(it); it != INVALID; notifier->next(it)) {
-          int id = Parent::getNotifier()->id(it);
+        const typename Parent::Notifier* notifier = Parent::notifier();
+        Item it;
+        for (notifier->first(it); it != INVALID; notifier->next(it)) {
+          int id = Parent::notifier()->id(it);
           fl[id] = true;
         }
         LEMON_ASSERT(fl == flag, MapError());
       }
-      container[Parent::getNotifier()->id(key)] = Value();
-      LEMON_ASSERT(flag[Parent::getNotifier()->id(key)], MapError());
-      flag[Parent::getNotifier()->id(key)] = false;
+      container[Parent::notifier()->id(key)] = Value();
+      LEMON_ASSERT(flag[Parent::notifier()->id(key)], MapError());
+      flag[Parent::notifier()->id(key)] = false;
     }
 
@@ -311,8 +311,8 @@
       if (strictCheck) {
         std::vector<bool> fl(flag.size(), false);
-        const typename Parent::Notifier* notifier = Parent::getNotifier();
-        Item it;
-        for (notifier->first(it); it != INVALID; notifier->next(it)) {
-          int id = Parent::getNotifier()->id(it);
+        const typename Parent::Notifier* notifier = Parent::notifier();
+        Item it;
+        for (notifier->first(it); it != INVALID; notifier->next(it)) {
+          int id = Parent::notifier()->id(it);
           fl[id] = true;
         }
@@ -320,7 +320,7 @@
       }
       for (int i = 0; i < (int)keys.size(); ++i) {
-	container[Parent::getNotifier()->id(keys[i])] = Value();
-        LEMON_ASSERT(flag[Parent::getNotifier()->id(keys[i])], MapError());
-        flag[Parent::getNotifier()->id(keys[i])] = false;
+	container[Parent::notifier()->id(keys[i])] = Value();
+        LEMON_ASSERT(flag[Parent::notifier()->id(keys[i])], MapError());
+        flag[Parent::notifier()->id(keys[i])] = false;
       }
     }
@@ -336,13 +336,13 @@
         }
       }
-      int size = Parent::getNotifier()->maxId() + 1;
+      int size = Parent::notifier()->maxId() + 1;
       container.reserve(size);
       container.resize(size);
       flag.reserve(size);
       flag.resize(size, false);
-      const typename Parent::Notifier* notifier = Parent::getNotifier();
-      Item it;
-      for (notifier->first(it); it != INVALID; notifier->next(it)) {
-        int id = Parent::getNotifier()->id(it);
+      const typename Parent::Notifier* notifier = Parent::notifier();
+      Item it;
+      for (notifier->first(it); it != INVALID; notifier->next(it)) {
+        int id = Parent::notifier()->id(it);
         LEMON_ASSERT(!flag[id], MapError());
         flag[id] = true;
@@ -355,8 +355,8 @@
     /// and it overrides the clear() member function of the observer base.     
     virtual void clear() { 
-      const typename Parent::Notifier* notifier = Parent::getNotifier();
-      Item it;
-      for (notifier->first(it); it != INVALID; notifier->next(it)) {
-        int id = Parent::getNotifier()->id(it);
+      const typename Parent::Notifier* notifier = Parent::notifier();
+      Item it;
+      for (notifier->first(it); it != INVALID; notifier->next(it)) {
+        int id = Parent::notifier()->id(it);
         LEMON_ASSERT(flag[id], MapError());
         flag[id] = false;