Index: lemon/bipartite_matching.h
===================================================================
--- lemon/bipartite_matching.h	(revision 2352)
+++ lemon/bipartite_matching.h	(revision 2386)
@@ -116,5 +116,5 @@
     /// It initalizes the data structures with an initial matching.
     template <typename MatchingMap>
-    void matchingInit(const MatchingMap& matching) {
+    void matchingInit(const MatchingMap& mm) {
       for (ANodeIt it(*graph); it != INVALID; ++it) {
         anode_matching[it] = INVALID;
@@ -125,5 +125,5 @@
       matching_size = 0;
       for (UEdgeIt it(*graph); it != INVALID; ++it) {
-        if (matching[it]) {
+        if (mm[it]) {
           ++matching_size;
           anode_matching[graph->aNode(it)] = it;
@@ -138,5 +138,5 @@
     /// \return %True when the given map contains really a matching.
     template <typename MatchingMap>
-    void checkedMatchingInit(const MatchingMap& matching) {
+    void checkedMatchingInit(const MatchingMap& mm) {
       for (ANodeIt it(*graph); it != INVALID; ++it) {
         anode_matching[it] = INVALID;
@@ -147,5 +147,5 @@
       matching_size = 0;
       for (UEdgeIt it(*graph); it != INVALID; ++it) {
-        if (matching[it]) {
+        if (mm[it]) {
           ++matching_size;
           if (anode_matching[graph->aNode(it)] != INVALID) {
@@ -188,5 +188,5 @@
       while (!success && !queue.empty()) {
         std::vector<Node> newqueue;
-        for (int i = 0; i < (int)queue.size(); ++i) {
+        for (int i = 0; i < int(queue.size()); ++i) {
           Node anode = queue[i];
           for (IncEdgeIt jt(*graph, anode); jt != INVALID; ++jt) {
@@ -214,5 +214,5 @@
         typename Graph::template ANodeMap<bool> aused(*graph, false);
         
-        for (int i = 0; i < (int)bqueue.size(); ++i) {
+        for (int i = 0; i < int(bqueue.size()); ++i) {
           Node bnode = bqueue[i];
 
@@ -280,5 +280,5 @@
       while (!queue.empty()) {
         std::vector<Node> newqueue;
-        for (int i = 0; i < (int)queue.size(); ++i) {
+        for (int i = 0; i < int(queue.size()); ++i) {
           Node anode = queue[i];
           for (IncEdgeIt jt(*graph, anode); jt != INVALID; ++jt) {
@@ -364,5 +364,5 @@
       while (!queue.empty()) {
         std::vector<Node> newqueue;
-        for (int i = 0; i < (int)queue.size(); ++i) {
+        for (int i = 0; i < int(queue.size()); ++i) {
           Node anode = queue[i];
           for (IncEdgeIt jt(*graph, anode); jt != INVALID; ++jt) {
@@ -404,8 +404,8 @@
     /// \return The number of the matching edges.
     template <typename MatchingMap>
-    int quickMatching(MatchingMap& matching) const {
+    int quickMatching(MatchingMap& mm) const {
       for (ANodeIt it(*graph); it != INVALID; ++it) {
         if (anode_matching[it] != INVALID) {
-          matching[anode_matching[it]] = true;
+          mm[anode_matching[it]] = true;
         }
       }
@@ -418,7 +418,7 @@
     /// \return The number of the matching edges.
     template <typename MatchingMap>
-    int matching(MatchingMap& matching) const {
+    int matching(MatchingMap& mm) const {
       for (UEdgeIt it(*graph); it != INVALID; ++it) {
-        matching[it] = it == anode_matching[graph->aNode(it)];
+        mm[it] = it == anode_matching[graph->aNode(it)];
       }
       return matching_size;
@@ -684,15 +684,15 @@
     /// automatically allocated map, of course.
     /// \return \c (*this)
-    MaxWeightedBipartiteMatching& heap(Heap& heap, HeapCrossRef &crossRef) {
+    MaxWeightedBipartiteMatching& heap(Heap& hp, HeapCrossRef &cr) {
       if(local_heap_cross_ref) {
 	delete _heap_cross_ref;
 	local_heap_cross_ref = false;
       }
-      _heap_cross_ref = &crossRef;
+      _heap_cross_ref = &cr;
       if(local_heap) {
 	delete _heap;
 	local_heap = false;
       }
-      _heap = &heap;
+      _heap = &hp;
       return *this;
     }
@@ -890,10 +890,10 @@
     /// for each edges. 
     template <typename PotentialMap>
-    void potential(PotentialMap& potential) const {
-      for (ANodeIt it(*graph); it != INVALID; ++it) {
-        potential[it] = anode_potential[it];
+    void potential(PotentialMap& pt) const {
+      for (ANodeIt it(*graph); it != INVALID; ++it) {
+        pt[it] = anode_potential[it];
       }
       for (BNodeIt it(*graph); it != INVALID; ++it) {
-        potential[it] = bnode_potential[it];
+        pt[it] = bnode_potential[it];
       }
     }
@@ -905,8 +905,8 @@
     /// \return The number of the matching edges.
     template <typename MatchingMap>
-    int quickMatching(MatchingMap& matching) const {
+    int quickMatching(MatchingMap& mm) const {
       for (ANodeIt it(*graph); it != INVALID; ++it) {
         if (anode_matching[it] != INVALID) {
-          matching[anode_matching[it]] = true;
+          mm[anode_matching[it]] = true;
         }
       }
@@ -919,7 +919,7 @@
     /// \return The number of the matching edges.
     template <typename MatchingMap>
-    int matching(MatchingMap& matching) const {
+    int matching(MatchingMap& mm) const {
       for (UEdgeIt it(*graph); it != INVALID; ++it) {
-        matching[it] = it == anode_matching[graph->aNode(it)];
+        mm[it] = it == anode_matching[graph->aNode(it)];
       }
       return matching_size;
@@ -1255,15 +1255,15 @@
     /// automatically allocated map, of course.
     /// \return \c (*this)
-    MinCostMaxBipartiteMatching& heap(Heap& heap, HeapCrossRef &crossRef) {
+    MinCostMaxBipartiteMatching& heap(Heap& hp, HeapCrossRef &cr) {
       if(local_heap_cross_ref) {
 	delete _heap_cross_ref;
 	local_heap_cross_ref = false;
       }
-      _heap_cross_ref = &crossRef;
+      _heap_cross_ref = &cr;
       if(local_heap) {
 	delete _heap;
 	local_heap = false;
       }
-      _heap = &heap;
+      _heap = &hp;
       return *this;
     }
@@ -1443,10 +1443,10 @@
     /// for each edges.
     template <typename PotentialMap>
-    void potential(PotentialMap& potential) const {
-      for (ANodeIt it(*graph); it != INVALID; ++it) {
-        potential[it] = anode_potential[it];
+    void potential(PotentialMap& pt) const {
+      for (ANodeIt it(*graph); it != INVALID; ++it) {
+        pt[it] = anode_potential[it];
       }
       for (BNodeIt it(*graph); it != INVALID; ++it) {
-        potential[it] = bnode_potential[it];
+        pt[it] = bnode_potential[it];
       }
     }
@@ -1458,8 +1458,8 @@
     /// \return The number of the matching edges.
     template <typename MatchingMap>
-    int quickMatching(MatchingMap& matching) const {
+    int quickMatching(MatchingMap& mm) const {
       for (ANodeIt it(*graph); it != INVALID; ++it) {
         if (anode_matching[it] != INVALID) {
-          matching[anode_matching[it]] = true;
+          mm[anode_matching[it]] = true;
         }
       }
@@ -1472,7 +1472,7 @@
     /// \return The number of the matching edges.
     template <typename MatchingMap>
-    int matching(MatchingMap& matching) const {
+    int matching(MatchingMap& mm) const {
       for (UEdgeIt it(*graph); it != INVALID; ++it) {
-        matching[it] = it == anode_matching[graph->aNode(it)];
+        mm[it] = it == anode_matching[graph->aNode(it)];
       }
       return matching_size;