Index: lemon/bellman_ford.h
===================================================================
--- lemon/bellman_ford.h	(revision 2394)
+++ lemon/bellman_ford.h	(revision 2408)
@@ -39,5 +39,5 @@
   ///  
   /// It defines all computational operations and constants which are
-  /// used in the bellman ford algorithm. The default implementation
+  /// used in the Bellman-Ford algorithm. The default implementation
   /// is based on the numeric_limits class. If the numeric type does not
   /// have infinity value then the maximum value is used as extremal
@@ -101,5 +101,5 @@
     typedef typename _LengthMap::Value Value;
 
-    /// \brief Operation traits for bellman-ford algorithm.
+    /// \brief Operation traits for Bellman-Ford algorithm.
     ///
     /// It defines the infinity type on the given Value type
@@ -411,6 +411,7 @@
     /// \brief Adds a new source node.
     ///
-    /// The optional second parameter is the initial distance of the node.
-    /// It just sets the distance of the node to the given value.
+    /// Adds a new source node. The optional second parameter is the 
+    /// initial distance of the node. It just sets the distance of the 
+    /// node to the given value.
     void addSource(Node source, Value dst = OperationTraits::zero()) {
       _dist->set(source, dst);
@@ -421,5 +422,5 @@
     }
 
-    /// \brief Executes one round from the bellman ford algorithm.
+    /// \brief Executes one round from the Bellman-Ford algorithm.
     ///
     /// If the algoritm calculated the distances in the previous round
@@ -464,5 +465,5 @@
     }
 
-    /// \brief Executes one weak round from the bellman ford algorithm.
+    /// \brief Executes one weak round from the Bellman-Ford algorithm.
     ///
     /// If the algorithm calculated the distances in the
@@ -518,5 +519,5 @@
     /// \pre init() must be called and at least one node should be added
     /// with addSource() before using this function. If there is
-    /// a negative cycles in the graph it gives back false.
+    /// a negative cycle in the graph it gives back false.
     ///
     /// This method runs the %BellmanFord algorithm from the root node(s)
@@ -608,5 +609,5 @@
     ///@{
 
-    /// \brief Lemon iterator for get a active nodes.
+    /// \brief Lemon iterator for get the active nodes.
     ///
     /// Lemon iterator for get the active nodes. This class provides a
@@ -785,5 +786,5 @@
     typedef typename _LengthMap::Value Value;
 
-    /// \brief Operation traits for bellman-ford algorithm.
+    /// \brief Operation traits for Bellman-Ford algorithm.
     ///
     /// It defines the infinity type on the given Value type
Index: lemon/circulation.h
===================================================================
--- lemon/circulation.h	(revision 2391)
+++ lemon/circulation.h	(revision 2408)
@@ -131,7 +131,7 @@
     bool checkX() { return checkX(_x); }
 
-    ///Chech if \c bar is a real barrier
-
-    ///Chech if \c bar is a real barrier
+    ///Check if \c bar is a real barrier
+
+    ///Check if \c bar is a real barrier
     ///\sa barrier()
     template<class GT>
@@ -151,7 +151,7 @@
       return _tol.negative(delta);
     }  
-    ///Chech whether or not the last execution provides a barrier
-
-    ///Chech whether or not the last execution provides a barrier
+    ///Check whether or not the last execution provides a barrier
+
+    ///Check whether or not the last execution provides a barrier
     ///\sa barrier()
     bool checkBarrier() 
Index: lemon/graph_adaptor.h
===================================================================
--- lemon/graph_adaptor.h	(revision 2392)
+++ lemon/graph_adaptor.h	(revision 2408)
@@ -1497,5 +1497,5 @@
   ///\endcode 
   ///
-  ///Then RevGraphAdaptor implements the graph structure with node-set
+  ///Then ResGraphAdaptor implements the graph structure with node-set
   /// \f$ V \f$ and edge-set \f$ A_{forward}\cup A_{backward} \f$,
   ///where \f$ A_{forward}=\{uv : uv\in A, f(uv)<c(uv)\} \f$ and 
Index: lemon/ssp_min_cost_flow.h
===================================================================
--- lemon/ssp_min_cost_flow.h	(revision 2396)
+++ lemon/ssp_min_cost_flow.h	(revision 2408)
@@ -189,6 +189,5 @@
     }
 
-    /// \brief The class is reset to zero flow and potential. The
-    /// class is reset to zero flow and potential.
+    /// \brief The class is reset to zero flow and potential.
     void reset() {
       total_length=0;
Index: lemon/time_measure.h
===================================================================
--- lemon/time_measure.h	(revision 2391)
+++ lemon/time_measure.h	(revision 2408)
@@ -234,22 +234,22 @@
   ///It is quite easy-to-use, here is a short example.
   ///\code
-  ///#include<lemon/time_measure.h>
-  ///#include<iostream>
-  ///
-  ///int main()
-  ///{
-  ///
-  ///  ...
-  ///
-  ///  Timer T;
-  ///  doSomething();
-  ///  std::cout << T << '\n';
-  ///  T.restart();
-  ///  doSomethingElse();
-  ///  std::cout << T << '\n';
-  ///
-  ///  ...
-  ///
-  ///}
+  /// #include<lemon/time_measure.h>
+  /// #include<iostream>
+  ///
+  /// int main()
+  /// {
+  ///
+  ///   ...
+  ///
+  ///   Timer T;
+  ///   doSomething();
+  ///   std::cout << T << '\n';
+  ///   T.restart();
+  ///   doSomethingElse();
+  ///   std::cout << T << '\n';
+  ///
+  ///   ...
+  ///
+  /// }
   ///\endcode
   ///